//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>
extern "C" {
#include <ggl.h>
}

#include "memblock.h"
#include "gstring.h"
#include "gui.h"
#include "resources.h"

// CLASS gFont IMPLEMENTATION


int gFont::TextWidth(char *Text)
{
	// CLIPPING
	
	int w;
	int totalwidth=0;
	
	while(*Text) {
		if(*Text=='\n' || *Text=='\r') return totalwidth;
	w=FontData->WidthMap[(int)(*Text)];
	totalwidth+=w>>16;
	++Text;	

	}
	return totalwidth;
}



gFont::gFont(int type=FONT_TINY)
{
	FontData=NULL;
	switch(type)
	{
	case FONT_SYSTEM6:
		FontData=(gFontData *)((void *)iSystem6Font);
		break;
	case FONT_SYSTEM7:
		FontData=(gFontData *)((void *)iSystem7Font);
		break;
	case FONT_SYSTEM8:
		FontData=(gFontData *)((void *)iSystem8Font);
		break;
	case FONT_MINI:
		FontData=(gFontData *)((void *)iMiniFont);
		break;
		
	case FONT_TINY:
		// USE 5 PIXEL FONT AS DEFAULT
	default:
		FontData=(gFontData *)((void *)iSystem5Font);
		
	}
	
			// DETERMINE MAXIMUM FONT CHARACTER WIDTH
			int f;
			MaxWidth=0;
			for(f=0;f<256;++f) {
				if((int)(FontData->WidthMap[f]>>16)>MaxWidth) MaxWidth=FontData->WidthMap[f]>>16;
			}
			
		return;

}

gFont::gFont(gFontData *data)
{
			FontData=data;	
			// DETERMINE MAXIMUM FONT CHARACTER WIDTH
			int f;
			MaxWidth=0;
			for(f=0;f<256;++f) {
				if((int)(FontData->WidthMap[f]>>16)>MaxWidth) MaxWidth=FontData->WidthMap[f]>>16;
			}
		return;

}
