//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_cplx.c 511 2007-11-13 01:42:01Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>

extern ULONGLONG __sat3_dbl2real(double value);

SAT_OBJECT sat3_createcplx_dbl(SAT_OBJECT where,double real,double imag)
{
ULONGLONG rreal,rimag;

    where=sat3_alloc(where,37);
	if(where==0) return 0;
	
	rreal=__sat3_dbl2real(real);
	rimag=__sat3_dbl2real(imag);
    

	sat3_poke(where,SAT_DOCMP,5);
    sat3_poke(where+5,(unsigned int)rreal,8);
    sat3_poke(where+13,(unsigned int)(rreal>>32),8);
    sat3_poke(where+21,(unsigned int)rimag,8);
    sat3_poke(where+29,(unsigned int)(rimag>>32),8);

    return where;
}


extern double __sat3_real2dbl(SAT_OBJECT realbody);


BOOL sat3_convertcplx_dbl(SAT_OBJECT real,double *creal,double *cimag)
{
if(!real) return 0;
if(sat3_isptr(real)) real=sat3_peek(real,5);
if(sat3_peek(real,5)!=SAT_DOCMP) return 0;	// RETURN 0.0 IF NOT A COMPLEX NUMBER

real+=5;
if(creal) *creal=__sat3_real2dbl(real);
real+=16;
if(cimag) *cimag=__sat3_real2dbl(real);
return TRUE;
}


SAT_OBJECT sat3_createcplx_int(SAT_OBJECT where,int real,int imag)
{
XREAL xr,xi;

xr_int2xr(real,&xr);
xr_int2xr(imag,&xi);

return sat3_createcplx_xreal(where,&xr,&xi);
}


BOOL sat3_convertcplx_int(SAT_OBJECT real,int *creal,int *cimag)
{
XREAL xr,xi;
if(!real) return 0;
if(sat3_isptr(real)) real=sat3_peek(real,5);
if(sat3_convertcplx_xreal(real,&xr,&xi)) {
if(creal) *creal=xr_xr2int(&xr);
if(cimag) *cimag=xr_xr2int(&xi);
return TRUE;
}

return 0;
}



SAT_OBJECT sat3_createcplx_llong(SAT_OBJECT where,LONGLONG creal,LONGLONG cimag)
{
XREAL xr,xi;

xr_llong2xr(creal,&xr);
xr_llong2xr(cimag,&xi);

return sat3_createcplx_xreal(where,&xr,&xi);
}


BOOL sat3_convertcplx_llong(SAT_OBJECT real,LONGLONG *creal,LONGLONG *cimag)
{
XREAL xr,xi;
if(!real) return 0;
if(sat3_isptr(real)) real=sat3_peek(real,5);
if(sat3_convertcplx_xreal(real,&xr,&xi)) {
if(creal) *creal=xr_xr2llong(&xr);
if(cimag) *cimag=xr_xr2llong(&xi);
return TRUE;
}
return 0;
}


#define LN2_LN10_32  19728	// DIV BY 65536

extern ULONGLONG __sat3_xreal2real(XREAL *value);


SAT_OBJECT sat3_createcplx_xreal(SAT_OBJECT where,XREAL *real,XREAL *imag)
{
ULONGLONG rreal,rimag;

    where=sat3_alloc(where,37);
	if(where==0) return 0;
    
	rreal=__sat3_xreal2real(real);
	rimag=__sat3_xreal2real(imag);

 	sat3_poke(where,SAT_DOCMP,5);
    sat3_poke(where+5,(unsigned int)rreal,8);
    sat3_poke(where+13,(unsigned int)(rreal>>32),8);
    sat3_poke(where+21,(unsigned int)rimag,8);
    sat3_poke(where+29,(unsigned int)(rimag>>32),8);

    return where;
}


extern void __sat3_real2xreal(SAT_OBJECT realbody,XREAL *result);


BOOL sat3_convertcplx_xreal(SAT_OBJECT real,XREAL *creal,XREAL *cimag)
{
if(!real) return 0;
if(sat3_isptr(real)) real=sat3_peek(real,5);
if(sat3_peek(real,5)!=SAT_DOCMP) return 0;

real+=5;
    
	__sat3_real2xreal(real,creal);
	__sat3_real2xreal(real+16,cimag);

	 return TRUE;
	 
}


extern ULONGLONG __ullbcdadd(ULONGLONG a,ULONGLONG b);

extern ULONGLONG __sat3_decn2real(decNumber *value);

SAT_OBJECT sat3_createcplx_decn(SAT_OBJECT where,decNumber *rpart,decNumber *ipart)
{
ULONGLONG real,imag;

    where=sat3_alloc(where,37);
	if(where==0) return 0;
    
	real=__sat3_decn2real(rpart);
	imag=__sat3_decn2real(ipart);

 	sat3_poke(where,SAT_DOCMP,5);
    sat3_poke(where+5,(unsigned int)real,8);
    sat3_poke(where+13,(unsigned int)(real>>32),8);
    sat3_poke(where+21,(unsigned int)imag,8);
    sat3_poke(where+29,(unsigned int)(imag>>32),8);

    return where;
}

extern void __sat3_real2decn(SAT_OBJECT realbody,decNumber *result);

BOOL sat3_convertcplx_decn(SAT_OBJECT cplx,decNumber *rpart,decNumber *ipart)
{
if(!cplx) return 0;
if(sat3_isptr(cplx)) cplx=sat3_peek(cplx,5);
if(sat3_peek(cplx,5)!=SAT_DOCMP) return 0;

cplx+=5;
__sat3_real2decn(cplx,rpart);

cplx+=16;
__sat3_real2decn(cplx,ipart);

	 return TRUE;
	 
}


