//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_getfreeuserob.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>

// AUXILIARY FUNCTION
// FINDS PAGE CLOSEST TO DSKTOP USED BY HPGCC
// RETURN 0xffffffff IF NONE, OR SATURN ADDRESS

SAT_OBJECT __find_main_ram_end()
{
int f;


int *ptr=(int *)_mmu_table_addr;
int maxaddr=sat3_s2a(0xffffc);
int minaddr=sat3_s2a(0x80000);
unsigned int page=0,a;

for(f=0;f<__mg->_mmu_table_entries;++f)
{
a=ptr[f]&0xfffff000;

if(a>minaddr && a<maxaddr && a>page) page=a;

}
if(page==0) return 0xffffffff;

return (SAT_OBJECT)(((page-minaddr)<<1)+0x82000);
}



// AUXILIARY FUNCTION, RETURNS THE AMOUNT OF USEABLE USEROB/STACK IN NIBBLES

int sat3_getfreeuserob()
{

    int dstk=sat3_peek(SAT_DSKTOP,5);
    SAT_OBJECT freeend;

    freeend=__find_main_ram_end();
	
    if(freeend==0xffffffff) {
		// C PROGRAM IS NOT USING MAIN RAM
		return dstk-sat3_peek(SAT_RSKTOP,5);
	}

	return dstk-freeend;

}


