//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_idnt.c 547 2008-02-06 01:01:02Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>


SAT_OBJECT sat3_createid_str(SAT_OBJECT where,char *string)
{
	if(!string) return 0;
int len=strlen(string);
    where=sat3_alloc(where,7+2*len);
	if(where==0) return 0;
	
	sat3_poke(where,SAT_DOIDNT,5);
    sat3_poke(where+5,len,5);
	int addr=where+7;
	
	while(len--) { sat3_poke(addr,*string++,2); addr+=2; }

    return where;
}


BOOL __sat3_convertid_str(SAT_OBJECT cstr,char *string, int maxchars)
{
int bytes;

bytes=(sat3_peek(cstr+5,2)+1);		// INCLUDES TRAILING ZERO


if(bytes>maxchars) bytes=maxchars;

bytes--;
cstr+=7;
while(bytes--) { *string++=sat3_peek(cstr,2); cstr+=2; }

*string=0;

return TRUE;
}


BOOL sat3_convertid_str(SAT_OBJECT cstr,char *string, int maxchars)
{
	if(!cstr) return 0;
	if(sat3_isptr(cstr)) cstr=sat3_peek(cstr,5);

if(sat3_peek(cstr,5)!=SAT_DOIDNT) return 0;	// RETURN 0 IF NOT A IDNT

return __sat3_convertid_str(cstr,string,maxchars);

}


int sat3_idlen(SAT_OBJECT idnt)
{
if(!idnt) return 0;
if(sat3_isptr(idnt)) idnt=sat3_peek(idnt,5);

int bytes;
int prolog=sat3_peek(idnt,5);
if(prolog!=SAT_DOIDNT && prolog!=SAT_DOTAG) return 0;	// RETURN 0 IF NOT A IDNT
bytes=sat3_peek(idnt+5,2);		// NOT INCLUDING TRAILING ZERO
	
return bytes;	
	
}

