//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


#include <hpgcc3.h>
#include <master_globals.h>

static void backTrack(){ //moves the cursor back one position

    int x,y;
    wherexy_orig(&x,&y);
    if((x==0)&&(y==0)) return; //already at start
        
    if(x==0){ //cursor is current at the start of a line - need to move it back one
        
        x=screen_width()-1; //move to end of previous line
        y--;
            
    }
    
    else x--; //otherwise just move back a character

    gotoxy_orig(x,y); //move to the new position

    return;
}

// GENERIC VERSION
char *gets(char *buffer)
{
	return (*(__console[__mg->__console_type].gets))(buffer);
}

// NO CONSOLE VERSION

char *dummy_gets(char *buffer)
{
	*buffer=0;
	return buffer;
}


char* gets_orig(char *buffer){ //gets function

    int i=0; //offset into buffer
    char key;

    while(1){

        key= getchar_orig(); //read in a character
        
        if(key==10) {
            // < ibl ; 2006-01-16 >
            // echo newline char
            putchar_orig(10);
            break; //newline, we're done
        }
        
        if((key!=0)&&(key!=8)){ //valid character
        
            buffer[i]=key; //save it
            putchar_orig(key); //and display it
            i++;
        }
        
        if(key==8){ //backspace key was hit
        
            if(i!=0){ //if we have not gone back too far
                i--; //move back a position in the buffer
                backTrack(); //and on-screen
                putchar_orig(' '); //erase the previous character
                backTrack(); //position over the space
            }
        }
        
    }
    buffer[i]=0; //write null terminator
    return buffer;

}

// GREYSCALE CONSOLE INCLUDED IN gconsole.cpp SINCE IT NEEDS C++
